'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;
// import { Window, TitleBar, Box, Form, Label, TextField, PushButton, SegmentedControl } from 'react-desktop/lib/OSX';


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Window = require('react-desktop/lib/Window/Window.osx');

var _Window2 = _interopRequireDefault(_Window);

var _TitleBar = require('react-desktop/lib/TitleBar/TitleBar.osx');

var _TitleBar2 = _interopRequireDefault(_TitleBar);

var _Box = require('react-desktop/lib/Box/Box.osx');

var _Box2 = _interopRequireDefault(_Box);

var _SegmentedControl = require('react-desktop/lib/SegmentedControl/SegmentedControl.osx');

var _SegmentedControl2 = _interopRequireDefault(_SegmentedControl);

var _Form = require('react-desktop/lib/Form/Form.common');

var _Form2 = _interopRequireDefault(_Form);

var _Label = require('react-desktop/lib/Label/Label.osx');

var _Label2 = _interopRequireDefault(_Label);

var _TextField = require('react-desktop/lib/TextInput/TextField.osx');

var _TextField2 = _interopRequireDefault(_TextField);

var _PushButton = require('react-desktop/lib/Button/PushButton.osx');

var _PushButton2 = _interopRequireDefault(_PushButton);

var _reactSwitcher = require('react-switcher');

var _reactSwitcher2 = _interopRequireDefault(_reactSwitcher);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Settings = (_temp = _class = function (_Component) {
  _inherits(Settings, _Component);

  function Settings(props) {
    _classCallCheck(this, Settings);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Settings).call(this, props));

    var isLocal = void 0;
    _this.options = {};
    if (props.socketOptions) {
      isLocal = true;
      _this.options.hostname = props.socketOptions.hostname;
      _this.options.port = props.socketOptions.port;
    } else {
      isLocal = false;
      _this.options.hostname = 'localhost';
      _this.options.port = '8000';
    }

    _this.state = {
      selectedTab: 'connection',
      isLocal: isLocal
    };
    return _this;
  }

  _createClass(Settings, [{
    key: 'changeTab',
    value: function changeTab(name) {
      this.setState({ selectedTab: name });
    }
  }, {
    key: 'isTab',
    value: function isTab(name) {
      return this.state.selectedTab === name;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var saveSettings = _props.saveSettings;
      var closeModal = _props.closeModal;

      return _react2.default.createElement(
        _Window2.default,
        { style: _styles2.default.window },
        _react2.default.createElement(_TitleBar2.default, { title: 'Settings', controls: false, onClosePress: closeModal }),
        _react2.default.createElement(
          _Box2.default,
          { className: 'box' },
          _react2.default.createElement(
            _SegmentedControl2.default,
            null,
            _react2.default.createElement(
              _SegmentedControl2.default.Item,
              { title: 'Connection',
                selected: this.isTab('connection'),
                onPress: function onPress() {
                  _this2.changeTab('connection');
                }
              },
              _react2.default.createElement(
                _Form2.default,
                { onSubmit: function onSubmit() {
                    saveSettings(_this2.state.isLocal, _this2.options);
                  } },
                _react2.default.createElement(
                  _Form2.default.Row,
                  null,
                  _react2.default.createElement(
                    _reactSwitcher2.default,
                    { on: this.state.isLocal, onClick: function onClick() {
                        return _this2.setState({ isLocal: !_this2.state.isLocal });
                      }, labelStyle: _styles2.default.switchLabel },
                    'Use local server'
                  )
                ),
                _react2.default.createElement(
                  _Form2.default.Row,
                  { visible: this.state.isLocal },
                  _react2.default.createElement(
                    _Label2.default,
                    null,
                    'Host name:'
                  ),
                  _react2.default.createElement(_TextField2.default, { defaultValue: this.options.hostname,
                    onChange: function onChange(e) {
                      _this2.options.hostname = e.target.value;
                    }
                  })
                ),
                _react2.default.createElement(
                  _Form2.default.Row,
                  { visible: this.state.isLocal },
                  _react2.default.createElement(
                    _Label2.default,
                    null,
                    'Port:'
                  ),
                  _react2.default.createElement(_TextField2.default, { defaultValue: this.options.port,
                    onChange: function onChange(e) {
                      _this2.options.port = e.target.value;
                    }
                  })
                ),
                _react2.default.createElement(
                  _Form2.default.Row,
                  null,
                  _react2.default.createElement(
                    _PushButton2.default,
                    { onPress: 'submit', push: true, color: 'blue' },
                    'Save'
                  ),
                  _react2.default.createElement(
                    _PushButton2.default,
                    { push: true, onClick: closeModal },
                    'Cancel'
                  )
                )
              )
            )
          )
        )
      );
    }
  }]);

  return Settings;
}(_react.Component), _class.propTypes = {
  closeModal: _react.PropTypes.func.isRequired,
  saveSettings: _react.PropTypes.func.isRequired,
  socketOptions: _react.PropTypes.object
}, _temp);
exports.default = Settings;
module.exports = exports['default'];