'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _localStorage = require('./utils/localStorage');

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _DevTools = require('./containers/DevTools');

var _DevTools2 = _interopRequireDefault(_DevTools);

var _createRemoteStore = require('./store/createRemoteStore');

var _ButtonBar = require('./components/ButtonBar');

var _ButtonBar2 = _interopRequireDefault(_ButtonBar);

var _Instances = require('./components/Instances');

var _Instances2 = _interopRequireDefault(_Instances);

var _SyncToggle = require('./components/SyncToggle');

var _SyncToggle2 = _interopRequireDefault(_SyncToggle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var App = (_temp = _class = function (_Component) {
  _inherits(App, _Component);

  function App(props) {
    _classCallCheck(this, App);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(App).call(this, props));

    _this.handleInstancesChanged = function (instance, name, toRemove) {
      var instances = _this.state.instances;
      if (toRemove) {
        delete instances[instance];
        _this.store.liftedStore.deleteInstance(instance);
        if (_this.state.instance === instance) {
          (0, _createRemoteStore.updateStoreInstance)('auto');
          _this.setState({ instance: 'auto', shouldSync: false, instances: instances });
          return;
        }
      } else instances[instance] = name || instance;
      _this.setState({ instances: instances });
    };

    _this.handleSelectInstance = function (e) {
      var instance = e.target.value;
      (0, _createRemoteStore.updateStoreInstance)(instance);
      _this.setState({ instance: instance, shouldSync: false });
    };

    _this.handleSelectMonitor = function (e) {
      _this.setState({ monitor: (0, _localStorage.saveSelectMonitor)(e.target.value) });
    };

    _this.handleSyncToggle = function () {
      var shouldSync = !_this.state.shouldSync;
      (0, _createRemoteStore.enableSync)(shouldSync);
      _this.setState({ shouldSync: shouldSync });
    };

    _this.state = {
      monitor: (0, _localStorage.getSelectMonitor)() || props.selectMonitor || 'default',
      modalIsOpen: false,
      instances: {},
      instance: 'auto',
      shouldSync: false
    };
    _this.socketOptions = (0, _localStorage.getSettings)() || props.socketOptions;
    _this.store = _this.createStore();

    _this.openModal = _this.openModal.bind(_this);
    _this.closeModal = _this.closeModal.bind(_this);
    _this.saveSettings = _this.saveSettings.bind(_this);
    return _this;
  }

  _createClass(App, [{
    key: 'createStore',
    value: function createStore() {
      return (0, _createRemoteStore.createRemoteStore)(this.socketOptions, this.handleInstancesChanged, this.state.instance);
    }
  }, {
    key: 'saveSettings',
    value: function saveSettings(isLocal, options) {
      this.socketOptions = (0, _localStorage.saveToStorage)(!isLocal, ['hostname', 'port'], options) || undefined;
      this.store = this.createStore();
      this.closeModal();
    }
  }, {
    key: 'openModal',
    value: function openModal(content) {
      this.modalContent = content;
      this.setState({ modal: this.modal, modalIsOpen: true });
    }
  }, {
    key: 'closeModal',
    value: function closeModal() {
      this.modalContent = null;
      this.setState({ modalIsOpen: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var monitor = this.state.monitor;

      var key = (this.socketOptions ? this.socketOptions.hostname : '') + this.state.instance;
      return _react2.default.createElement(
        'div',
        { style: _styles2.default.container },
        _react2.default.createElement(
          'div',
          { style: _styles2.default.buttonBar },
          _react2.default.createElement(
            'select',
            {
              style: _extends({}, _styles2.default.instances, _styles2.default.monitors),
              onChange: this.handleSelectMonitor
            },
            _DevTools.sideMonitors.map(function (item, i) {
              return _react2.default.createElement(
                'option',
                { key: i,
                  value: item.key,
                  selected: item.key === _this2.state.monitor
                },
                item.title
              );
            })
          ),
          _react2.default.createElement(_Instances2.default, { instances: this.state.instances, onSelect: this.handleSelectInstance }),
          _react2.default.createElement(_SyncToggle2.default, {
            on: this.state.shouldSync,
            onClick: this.handleSyncToggle,
            style: this.state.instance === 'auto' ? { display: 'none' } : null
          })
        ),
        _react2.default.createElement(_DevTools2.default, { monitor: monitor, store: this.store, key: monitor + '-' + key }),
        _react2.default.createElement(
          'div',
          { style: _styles2.default.sliderMonitor },
          _react2.default.createElement(_DevTools2.default, { monitor: 'SliderMonitor', store: this.store, key: 'Slider-' + key })
        ),
        this.props.noButtonBar ? null : _react2.default.createElement(_ButtonBar2.default, {
          openModal: this.openModal, closeModal: this.closeModal,
          saveSettings: this.saveSettings,
          socketOptions: this.socketOptions
        }),
        _react2.default.createElement(
          _reactModal2.default,
          { isOpen: this.state.modalIsOpen, onRequestClose: this.closeModal,
            style: _styles2.default.modal
          },
          this.modalContent
        )
      );
    }
  }]);

  return App;
}(_react.Component), _class.propTypes = {
  selectMonitor: _react.PropTypes.string,
  socketOptions: _react.PropTypes.shape({
    hostname: _react.PropTypes.string,
    port: _react.PropTypes.number,
    autoReconnect: _react.PropTypes.bool
  }),
  noButtonBar: _react.PropTypes.bool
}, _temp);
exports.default = App;
module.exports = exports['default'];