'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSettings = getSettings;
exports.getSelectMonitor = getSelectMonitor;
exports.saveToStorage = saveToStorage;
exports.saveSelectMonitor = saveSelectMonitor;

var _chromeStorageLocal = require('chrome-storage-local');

var _chromeStorageLocal2 = _interopRequireDefault(_chromeStorageLocal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getSettings() {
  if (!_chromeStorageLocal2.default.isChromeStorage) {
    var hostname = _chromeStorageLocal2.default.getItem('s:hostname');
    var port = _chromeStorageLocal2.default.getItem('s:port');
    if (hostname && port) return { hostname: hostname, port: Number(port) };
  }
  return null;
}

function getSelectMonitor() {
  if (_chromeStorageLocal2.default.isChromeStorage) return null;
  return _chromeStorageLocal2.default.getItem('select-monitor');
}

function saveToStorage(remove, keys, values) {
  if (remove) {
    keys.forEach(function (key) {
      _chromeStorageLocal2.default.removeItem('s:' + key);
    });
    return null;
  }

  var obj = {};
  keys.forEach(function (key) {
    _chromeStorageLocal2.default.setItem('s:' + key, values[key]);
    obj[key] = values[key];
  });
  return obj;
}

function saveSelectMonitor(name) {
  _chromeStorageLocal2.default.setItem('select-monitor', name);
  return name;
}